<template>
    <main>
        <div class="h1-container">
            <div class="h1-line"></div>
            <div class="clear"></div>
        </div>
        <div class="text-center ilts-ask-name">{{testQuestions.extra.section_name}}</div>
        <div class="ilts-time  text-center" v-if="remainTime===0">{{timeToPass}}</div>
        <div class="ilts-time  text-center" v-else>{{remainTime}}</div>
        <div v-if="!started">
            <div class="ilts-line"></div>
            <div class="pass flex-parent flex-justify-center flex-align-center" @click="start">ПРОЙТИ ТЕСТИРОВАНИЕ</div>
        </div>
        <div v-else>
            <div v-for="(question, index) in testQuestions.answers" v-bind:key="question.id">
                <div class="ask text-center">{{question.text}}</div>
                <div v-if="question.text_image"class="photo-ask" :style="{'background-image': 'url('+question.text_image+')'}"> </div>
                <div class="option flex-parent flex-column">
                    <div v-for="(choice, id) in question.answers_list" v-bind:key="id">
                        <div class="for-option flex-parent">

                        <input class="radio" type="checkbox" name="option" :value="id+1" v-model="listOfAnswers[index]" />
                        <div class="word-option">{{choice}}</div>
                    </div>
                </div>
                </div>
            </div>

        <button class=" a-btn" @click="finish">Проверить</button>
        </div>





    </main>
</template>

<script>
    function formatTime(t){
        var seconds = Math.floor((t / 1000) % 60);
        var minutes = Math.floor((t / 1000 / 60) % 60);
        if (minutes < 10) {minutes = "0"+minutes;}
        if (seconds < 10) {seconds = "0"+seconds;}
        return minutes + ':' + seconds
    }
    function startTimer(that) {
        var timeinterval = setInterval(function(){
            let time = localStorage.getItem('test_time_'+that.id)
            if(!time){
                clearInterval(timeinterval);
            }
            else {
                let t = Date.parse(time) - Date.parse(new Date());
                that.remainTime = formatTime(t);
                localStorage.setItem('test_time_' + that.id, time)
                if (t <= 0) {
                    if (that.testQuestions) {
                        localStorage.removeItem('test_time_' + that.id)
                        that.$store.dispatch('finishTest', that.listOfAnswers).then(() => {
                            that.$router.replace('TestResults');
                        });
                        clearInterval(timeinterval);
                    }
                }
            }
        },1000);

    }

    export default {
        name: 'Testing',
        props: ['id'],
        data(){
            return{
               started: false,
                remainTime: 0,
            }
        },
        beforeMount() {
            this.$store.dispatch('loadTestQuestions', this.id)
        },
        mounted(){
            let s = localStorage.getItem('test_time_'+this.id);
            if(s){
                let time;
                time = new Date(Date.parse(s))
                let that = this;
                this.started = true;
                startTimer(that)
            }
        },

        computed:{

            testQuestions(){
                let testQuestions = this.$store.getters.testQuestions;
                return testQuestions
            },
            listOfAnswers(){
                let listOfAnswers = this.$store.getters.listOfAnswers;
                return listOfAnswers
            },
            timeToPass(){
                let t = this.testQuestions.extra.time_to_pass*1000
                return formatTime(t)
            }
        },
        methods:{
            start(){
                this.started = true
                    if(this.testQuestions){
                        let time;
                        time = new Date(new Date().getTime() + this.testQuestions.extra.time_to_pass*1000)
                        let that = this;
                        localStorage.setItem('test_time_' + that.id, time)
                        startTimer(that)
                    }
            },
            finish(){
                let time = localStorage.getItem('test_time_'+this.id)
                let remain = Date.parse(time) - Date.parse(new Date());
                let estimated = this.testQuestions.extra.time_to_pass*1000 - remain;

                this.$store.dispatch('finishTest', {
                    answers: this.listOfAnswers,
                    estimatedTime: formatTime(estimated)
                }).then(()=>{
                    localStorage.removeItem('test_time_'+this.id)
                    this.$router.push({name:'TestResults'});
                });

            }
        }
    }
</script>
